import React from 'react';
import PropTypes from 'prop-types';

var PLACE_IDENTIFIER = '__isLayoutPlace__';
var HOC_DISPLAY_NAME = 'WithLayoutHOC';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};

var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var toArray$1 = function toArray$$1(x) {
    return Array.isArray(x) ? x : typeof x === 'undefined' ? [] : [x];
};

var isNotPlace = function isNotPlace() {
    var child = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (child === null) {
        return true;
    }
    var props = child.props,
        _child$type = child.type,
        type = _child$type === undefined ? {} : _child$type;

    return !type[PLACE_IDENTIFIER] || typeof props.toBe !== 'string' || props.toBe === '' || typeof props.children === 'undefined';
};

var groupChildren = function groupChildren(xs) {
    return xs.reduce(function (_ref, child) {
        var placeObj = _ref.placeObj,
            realChildren = _ref.realChildren;

        // child nodes that arn't `<Place>`
        // will be grouped in `children` prop
        if (isNotPlace(child)) {
            return {
                realChildren: [].concat(toConsumableArray(realChildren), [child]),
                placeObj: placeObj
            };
        }

        var _child$props = child.props,
            toBe = _child$props.toBe,
            children = _child$props.children;

        var childrenArray = toArray$1(children);

        // the rest will collect in either a new <Place> `toBe` key
        // or a key thats already in the set
        var newPlaceObj = _extends({}, placeObj, defineProperty({}, toBe, Array.isArray(placeObj[toBe]) ? [].concat(toConsumableArray(placeObj[toBe]), toConsumableArray(childrenArray)) : childrenArray));

        return { realChildren: realChildren, placeObj: newPlaceObj };
    }, {
        realChildren: [],
        placeObj: {}
    });
};

var withLayout = function withLayout(Component, options) {
    var WithLayoutHOC = function WithLayoutHOC() {
        var _babelHelpers$extends;

        var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var children = _ref.children,
            props = objectWithoutProperties(_ref, ['children']);

        var childArray = toArray$1(children);

        var _groupChildren = groupChildren(childArray),
            realChildren = _groupChildren.realChildren,
            placeObj = _groupChildren.placeObj;

        var validOptions = options && (typeof options === 'undefined' ? 'undefined' : _typeof(options)) === 'object' ? options : {};

        var customChildPropName = validOptions.customChildPropName;

        var customChildPropNameString = typeof customChildPropName === 'string' ? customChildPropName.trim() : '';

        var childPropName = customChildPropNameString && customChildPropNameString !== 'children' ? customChildPropNameString : 'child';

        var componentProps = _extends((_babelHelpers$extends = {}, defineProperty(_babelHelpers$extends, childPropName, placeObj), defineProperty(_babelHelpers$extends, 'children', realChildren), _babelHelpers$extends), props);

        return React.createElement(Component, componentProps);
    };

    WithLayoutHOC.propTypes = {
        children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
    };

    WithLayoutHOC.displayName = HOC_DISPLAY_NAME;

    return WithLayoutHOC;
};
var empty = {};
var Place = function Place(_ref2) {
    var _ref2$toBe = _ref2.toBe,
        _ref2$children = _ref2.children;
    return empty;
};

Place[PLACE_IDENTIFIER] = true;
Place.displayName = 'Place';
Place.propTypes = {
    toBe: PropTypes.string.isRequired,
    children: PropTypes.oneOfType([PropTypes.arrayOf(PropTypes.node), PropTypes.node])
};

export { withLayout, Place };
//# sourceMappingURL=index.es.js.map
